// ====================================================================
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) DIGITEO - 2009-2010 - Allan CORNET
// 
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at    
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================
mode(-1);
lines(0);

function builder()
    TOOLBOX_NAME  = "mingw";
    TOOLBOX_TITLE = "Mingw Compiler support for Scilab";
    toolbox_dir   = get_absolute_file_path("builder.sce");
    // =============================================================================
    // Check Scilab"s version
    // =============================================================================
    try
        v = getversion("scilab");
    catch
        error(gettext("Scilab 6.0 or more is required."));
    end

    if v(1) < 6 then
        error(gettext("Scilab 6.0 or more is required."));
    end
    // =============================================================================
    // Action
    // =============================================================================
    if getos() <> "Windows" then
        warning("Only for Windows Environment.");
        return;
    end

    tbx_builder_macros(toolbox_dir);
    tbx_builder_help(toolbox_dir);
    tbx_build_loader(toolbox_dir);
    tbx_build_cleaner(toolbox_dir);
endfunction

builder();
clear builder;
